{ This demoprogram shows how to use the binary logic functions implemented
  in ChroMathsome.
  The reader may do with this code whatever he/she desires.
  Author: John Merrit (john.merrit@net4all.be)
  Release date: ...
                                        
  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED
  WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.

  If you find it useful then I would appreciate any of the following:

  *  Comments, Suggestions, Bug finds etc.
  *  If you improve the interface, please send me a copy of the changes.
  
What I do not want is messages starting with "I am new to Delphi...". 
I've tried to place comments so that these demonstration programs should be readable enough.
Write to me if you have found a problem, not if you have a problem
which can be answered by posting to the comp.lang.delphi.components
newsgroup or any of the mathematics/numerical analysis newsgroups.               }

unit Bcalc;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, BinLogic;

type
  TForm1 = class(TForm)
    Number1Edit: TEdit;
    Number2Edit: TEdit;
    ResultEdit: TEdit;
    ByteSLeftButton: TButton;
    BitSLeftButton: TButton;
    BitSRightButton: TButton;
    ByteSRightButton: TButton;
    ORButton: TButton;
    XORButton: TButton;
    ANDButton: TButton;
    NOTButton: TButton;
    AddButton: TButton;
    SubtractButton: TButton;
    DivideButton: TButton;
    MultiplyButton: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    RadioGroup1: TRadioGroup;
    Label4: TLabel;
    procedure TwoArguments(Sender: TObject);
    procedure OneArgument(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
    function SetNumInBase(s: string; OldBase, NewBase: NumberBase): string;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Base: NumberBase;

implementation


{$R *.DFM}

{ This procedure handles the buttons that need two arguments. }
procedure TForm1.TwoArguments(Sender: TObject);
var s1, s2: string;
begin
     s1:= Number1Edit.Text;
     s2:= Number2Edit.Text;
     if Sender = AddButton then ResultEdit.Text:= BinAdd(s1,s2,Base)
     else if Sender = SubTractButton then ResultEdit.Text:= BinSubtract(s1,s2,Base)
     else if Sender = MultiplyButton then ResultEdit.Text:= BinMultiply(s1,s2,Base)
     else if Sender = DivideButton then ResultEdit.Text:= BinDivide(s1,s2,Base)
     else if Sender = ORButton then ResultEdit.Text:= BinOR(s1,s2,Base)
     else if Sender = XORButton then ResultEdit.Text:= BinXOR(s1,s2,Base)
     else if Sender = ANDButton then ResultEdit.Text:= BinAND(s1,s2,Base);
end;

{ This procedure handles the buttons that need one argument. }
procedure TForm1.OneArgument(Sender: TObject);
var s1: string;
begin
     s1:= Number1Edit.Text;
     if Sender = NOTButton then ResultEdit.Text:= BinNOT(s1,Base)
     else if Sender = BitSLeftButton then ResultEdit.Text:= BinShiftLeftBit(s1,Base)
     else if Sender = BitSRightButton then ResultEdit.Text:= BinShiftRightBit(s1,Base)
     else if Sender = ByteSLeftButton then ResultEdit.Text:= BinShiftLeftByte(s1,Base)
     else if Sender = ByteSRightButton then ResultEdit.Text:= BinShiftRightByte(s1,Base)
end;

{ Changes the number from base OldBase to base NewBase. }
function TForm1.SetNumInBase(s: string; OldBase, NewBase: NumberBase): string;
var LI: Cardinal;
begin
     case OldBase of
     Dec:begin
              LI:= StrToInt(s);
	      case NewBase of
              Bin: s:= IntToBin(LI);
              Oct: s:= IntToOct(LI);
              Hex: s:= MIntToHex(LI);
         end;
         end;
     Bin:begin
	      case NewBase of
              Dec: s:= IntToStr(BinToInt(s));
              Oct: s:= BinToOct(s);
              Hex: s:= BinToHex(s);
         end;
         end;
     Oct:begin
	      case NewBase of
              Bin: s:= OctToBin(s);
              Dec: s:= IntToStr(OctToInt(s));
              Hex: s:= OctToHex(s);
         end;
         end;
     Hex:begin
	      case NewBase of
              Bin: s:= HexToBin(s);
              Oct: s:= HexToOct(s);
              Dec: s:= IntToStr(HexToInt(s));
         end;
         end;
     end;
     SetNumInBase:= s;
end;


{ Change the number base.
  Note that this procedure will convert the numbers in Number1Edit and Number2Edit and
  ResultEdit (if they are present).
  Also note that, since this is only a simple demonstration program, no errortrapping will be done.
  If, for example, the number in Number1Edit is 100A25Z and you change the number base (from Hex to ...),
  the base change will be performed and ChroMathsome will report an error.                      }
procedure TForm1.RadioGroup1Click(Sender: TObject);
var OldBase: NumberBase;
    s1, s2, s3: string;
begin
      s1:= Number1Edit.Text;
      s2:= Number2Edit.Text;
      s3:= ResultEdit.Text;
      OldBase:= Base;
      case RadioGroup1.ItemIndex of
      0:begin
        Base:= DEC;
        Label4.Caption:= 'Decimal';
        if OldBase <> Base then
        begin
	case OldBase of
        Bin:begin
	   if s1 <> '' then Number1Edit.Text:= SetNumInBase(s1,OldBase,Base);
 	   if s2 <> '' then Number2Edit.Text:= SetNumInBase(s2,OldBase,Base);
           if s3 <> '' then ResultEdit.Text:= SetNumInBase(s3,OldBase,Base);
           end;
        Oct:begin
	   if s1 <> '' then Number1Edit.Text:= SetNumInBase(s1,OldBase,Base);
 	   if s2 <> '' then Number2Edit.Text:= SetNumInBase(s2,OldBase,Base);
           if s3 <> '' then ResultEdit.Text:= SetNumInBase(s3,OldBase,Base);
           end;
	Hex:begin
	   if s1 <> '' then Number1Edit.Text:= SetNumInBase(s1,OldBase,Base);
 	   if s2 <> '' then Number2Edit.Text:= SetNumInBase(s2,OldBase,Base);
           if s3 <> '' then ResultEdit.Text:= SetNumInBase(s3,OldBase,Base);
           end;
	end;
	end;
        end;
      1:begin
        Base:= Bin;
        Label4.Caption:= 'Binary';
        if OldBase <> Base then
        begin
	case OldBase of
        Dec:begin
	   if s1 <> '' then Number1Edit.Text:= SetNumInBase(s1,OldBase,Base);
 	   if s2 <> '' then Number2Edit.Text:= SetNumInBase(s2,OldBase,Base);
           if s3 <> '' then ResultEdit.Text:= SetNumInBase(s3,OldBase,Base);
           end;
        Oct:begin
	   if s1 <> '' then Number1Edit.Text:= SetNumInBase(s1,OldBase,Base);
 	   if s2 <> '' then Number2Edit.Text:= SetNumInBase(s2,OldBase,Base);
           if s3 <> '' then ResultEdit.Text:= SetNumInBase(s3,OldBase,Base);
           end;
	Hex:begin
	   if s1 <> '' then Number1Edit.Text:= SetNumInBase(s1,OldBase,Base);
 	   if s2 <> '' then Number2Edit.Text:= SetNumInBase(s2,OldBase,Base);
           if s3 <> '' then ResultEdit.Text:= SetNumInBase(s3,OldBase,Base);
           end;
	end;
	end;
        end;
      2:begin
        Base:= Oct;
        Label4.Caption:= 'Octal';
        if OldBase <> Base then
        begin
	case OldBase of
        Bin:begin
	   if s1 <> '' then Number1Edit.Text:= SetNumInBase(s1,OldBase,Base);
 	   if s2 <> '' then Number2Edit.Text:= SetNumInBase(s2,OldBase,Base);
           if s3 <> '' then ResultEdit.Text:= SetNumInBase(s3,OldBase,Base);
           end;
        Dec:begin
	   if s1 <> '' then Number1Edit.Text:= SetNumInBase(s1,OldBase,Base);
 	   if s2 <> '' then Number2Edit.Text:= SetNumInBase(s2,OldBase,Base);
           if s3 <> '' then ResultEdit.Text:= SetNumInBase(s3,OldBase,Base);
           end;
	Hex:begin
	   if s1 <> '' then Number1Edit.Text:= SetNumInBase(s1,OldBase,Base);
 	   if s2 <> '' then Number2Edit.Text:= SetNumInBase(s2,OldBase,Base);
           if s3 <> '' then ResultEdit.Text:= SetNumInBase(s3,OldBase,Base);
           end;
	end;
	end;
        end;
      3:begin
        Base:= Hex;
        Label4.Caption:= 'Hexadecimal';
        if OldBase <> Base then
        begin
	case OldBase of
        Bin:begin
	   if s1 <> '' then Number1Edit.Text:= SetNumInBase(s1,OldBase,Base);
 	   if s2 <> '' then Number2Edit.Text:= SetNumInBase(s2,OldBase,Base);
           if s3 <> '' then ResultEdit.Text:= SetNumInBase(s3,OldBase,Base);
           end;
        Oct:begin
	   if s1 <> '' then Number1Edit.Text:= SetNumInBase(s1,OldBase,Base);
 	   if s2 <> '' then Number2Edit.Text:= SetNumInBase(s2,OldBase,Base);
           if s3 <> '' then ResultEdit.Text:= SetNumInBase(s3,OldBase,Base);
           end;
	Dec:begin
	   if s1 <> '' then Number1Edit.Text:= SetNumInBase(s1,OldBase,Base);
 	   if s2 <> '' then Number2Edit.Text:= SetNumInBase(s2,OldBase,Base);
           if s3 <> '' then ResultEdit.Text:= SetNumInBase(s3,OldBase,Base);
           end;
	end;
	end;
        end;
	end;
	end;

{ Initialize the Form and the number base. }
procedure TForm1.FormActivate(Sender: TObject);
begin
     RadioGroup1.ItemIndex:= 0;
     Label4.Caption:= 'Decimal';
     Base:= Dec;
end;

end.
